<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FareGroupService ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FareGroupService extends AbstractStructArrayBase
{
    /**
     * The FareGroupService
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FareGroupService[]
     */
    public $FareGroupService;
    /**
     * Constructor method for ArrayOfJP_FareGroupService
     * @uses ArrayOfJP_FareGroupService::setFareGroupService()
     * @param \StructType\JP_FareGroupService[] $fareGroupService
     */
    public function __construct(array $fareGroupService = array())
    {
        $this
            ->setFareGroupService($fareGroupService);
    }
    /**
     * Get FareGroupService value
     * @return \StructType\JP_FareGroupService[]|null
     */
    public function getFareGroupService()
    {
        return $this->FareGroupService;
    }
    /**
     * Set FareGroupService value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroupService[] $fareGroupService
     * @return \ArrayType\ArrayOfJP_FareGroupService
     */
    public function setFareGroupService(array $fareGroupService = array())
    {
        foreach ($fareGroupService as $arrayOfJP_FareGroupServiceFareGroupServiceItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FareGroupServiceFareGroupServiceItem instanceof \StructType\JP_FareGroupService) {
                throw new \InvalidArgumentException(sprintf('The FareGroupService property can only contain items of \StructType\JP_FareGroupService, "%s" given', is_object($arrayOfJP_FareGroupServiceFareGroupServiceItem) ? get_class($arrayOfJP_FareGroupServiceFareGroupServiceItem) : gettype($arrayOfJP_FareGroupServiceFareGroupServiceItem)), __LINE__);
            }
        }
        $this->FareGroupService = $fareGroupService;
        return $this;
    }
    /**
     * Add item to FareGroupService value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroupService $item
     * @return \ArrayType\ArrayOfJP_FareGroupService
     */
    public function addToFareGroupService(\StructType\JP_FareGroupService $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FareGroupService) {
            throw new \InvalidArgumentException(sprintf('The FareGroupService property can only contain items of \StructType\JP_FareGroupService, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->FareGroupService[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FareGroupService|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FareGroupService|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FareGroupService|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FareGroupService|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FareGroupService|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareGroupService
     */
    public function getAttributeName()
    {
        return 'FareGroupService';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_FareGroupService
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
